const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const purchase_invoice_lines = sequelize.define(
    'purchase_invoice_lines',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

description: {
        type: DataTypes.TEXT,
      
      

      },

quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

unit_price: {
        type: DataTypes.DECIMAL,
      
      

      },

line_subtotal: {
        type: DataTypes.DECIMAL,
      
      

      },

vat_treatment: {
        type: DataTypes.ENUM,
      
      

        values: [

"standard_15",


"zero_rated",


"exempt",


"not_applicable"

        ],

      },

vat_amount: {
        type: DataTypes.DECIMAL,
      
      

      },

line_total: {
        type: DataTypes.DECIMAL,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  purchase_invoice_lines.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

























//end loop



    db.purchase_invoice_lines.belongsTo(db.purchase_invoices, {
      as: 'purchase_invoice',
      foreignKey: {
        name: 'purchase_invoiceId',
      },
      constraints: false,
    });

    db.purchase_invoice_lines.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });

    db.purchase_invoice_lines.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.purchase_invoice_lines.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.purchase_invoice_lines.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return purchase_invoice_lines;
};


